library angular2.src.core.forms.directives.validators;

import "package:angular2/src/core/di.dart" show Provider, OpaqueToken;
import "package:angular2/src/core/metadata.dart" show Attribute, Directive;
import "../validators.dart" show Validators, NG_VALIDATORS;
import "package:angular2/src/core/facade/lang.dart" show NumberWrapper;

const REQUIRED_VALIDATOR =
    const Provider(NG_VALIDATORS, useValue: Validators.required, multi: true);

@Directive(
    selector:
        "[required][ng-control],[required][ng-form-control],[required][ng-model]",
    providers: const [REQUIRED_VALIDATOR])
class RequiredValidator {}

dynamic createMinLengthValidator(dir) {
  return Validators.minLength(dir.minLength);
}

const MIN_LENGTH_VALIDATOR = const Provider(NG_VALIDATORS,
    useFactory: createMinLengthValidator,
    deps: const [MinLengthValidator],
    multi: true);

@Directive(
    selector:
        "[minlength][ng-control],[minlength][ng-form-control],[minlength][ng-model]",
    providers: const [MIN_LENGTH_VALIDATOR])
class MinLengthValidator {
  num minLength;
  MinLengthValidator(@Attribute("minlength") String minLength) {
    this.minLength = NumberWrapper.parseInt(minLength, 10);
  }
}

dynamic createMaxLengthValidator(dir) {
  return Validators.maxLength(dir.maxLength);
}

const MAX_LENGTH_VALIDATOR = const Provider(NG_VALIDATORS,
    useFactory: createMaxLengthValidator,
    deps: const [MaxLengthValidator],
    multi: true);

@Directive(
    selector:
        "[maxlength][ng-control],[maxlength][ng-form-control],[maxlength][ng-model]",
    providers: const [MAX_LENGTH_VALIDATOR])
class MaxLengthValidator {
  num maxLength;
  MaxLengthValidator(@Attribute("maxlength") String maxLength) {
    this.maxLength = NumberWrapper.parseInt(maxLength, 10);
  }
}
