library angular2.test.core.compiler.schema_registry_mock;

import "package:angular2/src/core/compiler/schema/element_schema_registry.dart"
    show ElementSchemaRegistry;
import "package:angular2/src/core/facade/lang.dart" show isPresent;

class MockSchemaRegistry implements ElementSchemaRegistry {
  Map<String, bool> existingProperties;
  Map<String, String> attrPropMapping;
  MockSchemaRegistry(this.existingProperties, this.attrPropMapping) {}
  bool hasProperty(String tagName, String property) {
    var result = this.existingProperties[property];
    return isPresent(result) ? result : true;
  }

  String getMappedPropName(String attrName) {
    var result = this.attrPropMapping[attrName];
    return isPresent(result) ? result : attrName;
  }
}
